import { Body, Controller, Delete, Get, Param, Post, Put } from '@nestjs/common';

import { BroadcastService } from './broadcast.service';

@Controller('/api/broadcast')
export class BroadcastController {

    constructor(private broadcastService: BroadcastService) {}

    @Post()
    public async create(@Body('title') title: string, @Body('body') body: string, @Body('replaySend') replaySend: boolean) {
        const broadcast = await this.broadcastService.create(title, body, replaySend);
        return { id: broadcast.id };
    }

    @Get(':id')
    public async one(@Param('id') id: string) {
        const broadcast = await this.broadcastService.one({ id });
        return broadcast;
    }

    @Put(':id')
    public async update(@Param('id') id: string, @Body('title') title: string, @Body('body') body: string, @Body('replaySend') replaySend: boolean) {
        await this.broadcastService.update(id, title, body, replaySend);
        return 'Broadcast successfully updated';
    }

    @Delete(':id')
    public async remove(@Param('id') id: string) {
        const broadcast = await this.broadcastService.one({ id });
        await this.broadcastService.remove([broadcast]);
        return 'Broadcast successfully deleted';
    }

}
