import { Column, CreateDateColumn, Entity, PrimaryGeneratedColumn, Unique, UpdateDateColumn } from 'typeorm';

// TODO: attachment, organizer
@Entity({ name: 'broadcasts' })
@Unique(['id'])
export class Broadcast {

  @PrimaryGeneratedColumn('uuid')
  public id: string;

  @Column()
  public title: string;

  @Column({ type: 'text' })
  public body: string;

  @Column({ default: true })
  public replaySend: boolean;

  @Column({ nullable: true })
  public dateSent?: Date;

  @UpdateDateColumn()
  public dateModified: Date;

  @CreateDateColumn()
  public dateCreated: Date;
}
