import { MiddlewareConsumer, Module, NestModule } from '@nestjs/common';
import { ConfigModule } from '@nestjs/config';

import { EventsModule } from '../events/events.module';
import { UserModule } from '../user/user.module';

import { ChatbotAdapterModule } from './chatbot.adapter.module';
import { ChatbotController } from './chatbot.controller';
import { ChatbotHandler } from './chatbot.handler';
import { ChatbotService } from './chatbot.service';

@Module({
  imports: [
    ConfigModule,
    ChatbotAdapterModule.register(),
    UserModule,
    EventsModule
  ],
  controllers: [ChatbotController],
  providers: [
    ChatbotHandler,
    ChatbotService
  ]
})
export class ChatbotModule implements NestModule {

  public configure(consumer: MiddlewareConsumer) {
    console.log('\nGet Bot Framework Emulator: https://aka.ms/botframework-emulator');
    console.log('\nTo talk to your bot, open the emulator select "Open Bot"');
  }

}
