import { Column, CreateDateColumn, Entity, ManyToOne, PrimaryGeneratedColumn } from 'typeorm';

import { User } from '../user/user.entity';

import { Event } from './event.entity';

export enum EventAttendance {
    accepted = 'accepted',
    maybe = 'maybe',
    declined = 'declined'
}

@Entity('event_attendees')
export class EventAttendee {

    @PrimaryGeneratedColumn()
    public id: number;

    @ManyToOne((type) => User, {
        onDelete: 'CASCADE',
        eager: true
    })
    public user: User;

    @ManyToOne((type) => Event, {
        onDelete: 'CASCADE',
        eager: true
    })
    public event: Event;

    @CreateDateColumn()
    public dateAdded: Date;

    @Column({ type: 'enum', enum: EventAttendance })
    public status: EventAttendance;
}
