import { Column, Entity, PrimaryGeneratedColumn } from 'typeorm';

import { EventAttendance } from './attendee.entity';

@Entity('events')
export class Event {

    @PrimaryGeneratedColumn('uuid')
    public id: string;

    @Column()
    public title: string;

    @Column()
    public location: string;

    @Column({ type: 'varchar', length: 2000 })
    public description: string;

    @Column({ type: 'int', width: 11, unsigned: true })
    public dateStart: number;

    @Column({ type: 'int', width: 11, unsigned: true })
    public dateEnd: number;

    @Column({ type: 'int', width: 11, unsigned: true })
    public dateModified: number;

    @Column({ type: 'int', width: 11, unsigned: true })
    public dateCreated: number;

    @Column({ type: 'varchar' })
    public imageUrl: string;

    public attend: EventAttendance;
}
