import { forwardRef, HttpModule, Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';

import { JobsModule } from '../jobs/jobs.module';
import { UserModule } from '../user/user.module';

import { EventAttendee } from './attendee.entity';
import { Event } from './event.entity';
import { EventsController } from './events.controller';
import { EventsService } from './events.service';

@Module({
  imports: [
    TypeOrmModule.forFeature([Event, EventAttendee]),
    JobsModule,
    forwardRef(() => UserModule)
  ],
  controllers: [
    EventsController
  ],
  providers: [
    EventsService
  ],
  exports: [
    TypeOrmModule,
    EventsService
  ]
})
export class EventsModule { }
