import {MigrationInterface, QueryRunner} from 'typeorm';

export class User1575129903461 implements MigrationInterface {
    public name = 'User1575129903461';

    public async up(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('CREATE TABLE `user` (`id` varchar(36) NOT NULL, `telegramId` varchar(255) NOT NULL, `publicId` int NOT NULL, `name` varchar(255) NOT NULL, UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` (`id`, `telegramId`, `publicId`), PRIMARY KEY (`id`)) ENGINE=InnoDB', undefined);
        await queryRunner.query('CREATE TABLE `session` (`id` varchar(36) NOT NULL, `userAgent` varchar(255) NOT NULL, `dateStarted` datetime(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6), `userId` varchar(36) NULL, UNIQUE INDEX `IDX_f55da76ac1c3ac420f444d2ff1` (`id`), UNIQUE INDEX `REL_3d2f174ef04fb312fdebd0ddc5` (`userId`), PRIMARY KEY (`id`)) ENGINE=InnoDB', undefined);
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` ON `user` (`id`, `telegramId`, `publicId`)', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
    }

    public async down(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` ON `user` (`id`, `telegramId`, `publicId`)', undefined);
        await queryRunner.query('DROP INDEX `REL_3d2f174ef04fb312fdebd0ddc5` ON `session`', undefined);
        await queryRunner.query('DROP INDEX `IDX_f55da76ac1c3ac420f444d2ff1` ON `session`', undefined);
        await queryRunner.query('DROP TABLE `session`', undefined);
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('DROP TABLE `user`', undefined);
    }

}
