import {MigrationInterface, QueryRunner} from 'typeorm';

export class User1578177939609 implements MigrationInterface {
    public name = 'User1578177939609';

    public async up(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('ALTER TABLE `broadcasts` CHANGE `dateSent` `dateSent` datetime NULL', undefined);
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('ALTER TABLE `session` DROP PRIMARY KEY', undefined);
        await queryRunner.query('DROP INDEX `IDX_f55da76ac1c3ac420f444d2ff1` ON `session`', undefined);
        await queryRunner.query('ALTER TABLE `session` DROP COLUMN `id`', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD `id` varchar(255) NOT NULL PRIMARY KEY', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD UNIQUE INDEX `IDX_f55da76ac1c3ac420f444d2ff1` (`id`)', undefined);
        await queryRunner.query('ALTER TABLE `session` CHANGE `userId` `userId` varchar(36) NULL', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` ON `user` (`id`, `telegramId`, `publicId`)', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
    }

    public async down(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('ALTER TABLE `session` CHANGE `userId` `userId` varchar(36) NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `session` DROP INDEX `IDX_f55da76ac1c3ac420f444d2ff1`', undefined);
        await queryRunner.query('ALTER TABLE `session` DROP COLUMN `id`', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD `id` varchar(36) NOT NULL', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_f55da76ac1c3ac420f444d2ff1` ON `session` (`id`)', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD PRIMARY KEY (`id`)', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` ON `user` (`id`, `telegramId`, `publicId`)', undefined);
        await queryRunner.query('ALTER TABLE `broadcasts` CHANGE `dateSent` `dateSent` datetime NULL DEFAULT \'NULL\'', undefined);
    }

}
