import {MigrationInterface, QueryRunner} from 'typeorm';

export class Organiser1578989990791 implements MigrationInterface {
    public name = 'Organiser1578989990791';

    public async up(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('CREATE TABLE `organiser` (`id` varchar(36) NOT NULL, `name` varchar(255) NOT NULL, `desc` text NULL, `dateCreated` datetime(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6), UNIQUE INDEX `IDX_94a8fd290508eeae02d794fe06` (`id`, `name`), PRIMARY KEY (`id`)) ENGINE=InnoDB', undefined);
        await queryRunner.query('CREATE TABLE `user_meta` (`id` int NOT NULL AUTO_INCREMENT, `key` varchar(255) NOT NULL, `value` text NOT NULL, `dateCreated` datetime(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6), `userId` varchar(36) NULL, UNIQUE INDEX `IDX_cede5795d48754d93e2636fa44` (`key`, `value`, `userId`), PRIMARY KEY (`id`)) ENGINE=InnoDB', undefined);
        await queryRunner.query('ALTER TABLE `user` ADD `dateCreated` datetime(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6)', undefined);
        await queryRunner.query('ALTER TABLE `broadcasts` CHANGE `dateSent` `dateSent` datetime NULL', undefined);
        await queryRunner.query('DROP INDEX `IDX_94a8fd290508eeae02d794fe06` ON `organiser`', undefined);
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('ALTER TABLE `session` CHANGE `userId` `userId` varchar(36) NULL', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_94a8fd290508eeae02d794fe06` ON `organiser` (`id`, `name`)', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` ON `user` (`id`, `telegramId`, `publicId`)', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` ADD CONSTRAINT `FK_f6c72c83c1787aee12530dbcd05` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
    }

    public async down(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('ALTER TABLE `user_meta` DROP FOREIGN KEY `FK_f6c72c83c1787aee12530dbcd05`', undefined);
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('DROP INDEX `IDX_94a8fd290508eeae02d794fe06` ON `organiser`', undefined);
        await queryRunner.query('ALTER TABLE `session` CHANGE `userId` `userId` varchar(36) NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` ON `user` (`id`, `telegramId`, `publicId`)', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_94a8fd290508eeae02d794fe06` ON `organiser` (`id`, `name`)', undefined);
        await queryRunner.query('ALTER TABLE `broadcasts` CHANGE `dateSent` `dateSent` datetime NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `user` DROP COLUMN `dateCreated`', undefined);
        await queryRunner.query('DROP INDEX `IDX_cede5795d48754d93e2636fa44` ON `user_meta`', undefined);
        await queryRunner.query('DROP TABLE `user_meta`', undefined);
        await queryRunner.query('DROP INDEX `IDX_94a8fd290508eeae02d794fe06` ON `organiser`', undefined);
        await queryRunner.query('DROP TABLE `organiser`', undefined);
    }

}
