import {MigrationInterface, QueryRunner} from 'typeorm';

export class CascadeFix1579301886356 implements MigrationInterface {
    public name = 'CascadeFix1579301886356';

    public async up(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` DROP FOREIGN KEY `FK_f6c72c83c1787aee12530dbcd05`', undefined);
        await queryRunner.query('ALTER TABLE `broadcasts` CHANGE `dateSent` `dateSent` datetime NULL', undefined);
        await queryRunner.query('ALTER TABLE `organiser` CHANGE `desc` `desc` text NULL', undefined);
        await queryRunner.query('ALTER TABLE `session` CHANGE `userId` `userId` varchar(36) NULL', undefined);
        await queryRunner.query('DROP INDEX `IDX_cede5795d48754d93e2636fa44` ON `user_meta`', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` CHANGE `userId` `userId` varchar(36) NULL', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_cede5795d48754d93e2636fa44` ON `user_meta` (`key`, `value`, `userId`)', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE CASCADE ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` ADD CONSTRAINT `FK_f6c72c83c1787aee12530dbcd05` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE CASCADE ON UPDATE NO ACTION', undefined);
    }

    public async down(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('ALTER TABLE `user_meta` DROP FOREIGN KEY `FK_f6c72c83c1787aee12530dbcd05`', undefined);
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('DROP INDEX `IDX_cede5795d48754d93e2636fa44` ON `user_meta`', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` CHANGE `userId` `userId` varchar(36) NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_cede5795d48754d93e2636fa44` ON `user_meta` (`key`, `value`, `userId`)', undefined);
        await queryRunner.query('ALTER TABLE `session` CHANGE `userId` `userId` varchar(36) NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `organiser` CHANGE `desc` `desc` text NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `broadcasts` CHANGE `dateSent` `dateSent` datetime NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` ADD CONSTRAINT `FK_f6c72c83c1787aee12530dbcd05` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
    }

}
