import {MigrationInterface, QueryRunner} from 'typeorm';

export class Jobs1579876145751 implements MigrationInterface {
    public name = 'Jobs1579876145751';

    public async up(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('DROP INDEX `REL_3d2f174ef04fb312fdebd0ddc5` ON `session`', undefined);
        await queryRunner.query('CREATE TABLE `jobs` (`id` int NOT NULL AUTO_INCREMENT, `trigger` varchar(255) NOT NULL, `status` varchar(255) NULL, `runOn` datetime NOT NULL, `dateAdded` datetime(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6), `args` text NOT NULL, PRIMARY KEY (`id`)) ENGINE=InnoDB', undefined);
        await queryRunner.query('ALTER TABLE `broadcasts` CHANGE `dateSent` `dateSent` datetime NULL', undefined);
        await queryRunner.query('ALTER TABLE `organiser` CHANGE `desc` `desc` text NULL', undefined);
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('ALTER TABLE `session` CHANGE `userId` `userId` varchar(36) NULL', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` DROP FOREIGN KEY `FK_f6c72c83c1787aee12530dbcd05`', undefined);
        await queryRunner.query('DROP INDEX `IDX_cede5795d48754d93e2636fa44` ON `user_meta`', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` CHANGE `userId` `userId` varchar(36) NULL', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` ON `user` (`id`, `telegramId`, `publicId`)', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_cede5795d48754d93e2636fa44` ON `user_meta` (`key`, `value`, `userId`)', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE CASCADE ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` ADD CONSTRAINT `FK_f6c72c83c1787aee12530dbcd05` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE CASCADE ON UPDATE NO ACTION', undefined);
    }

    public async down(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('ALTER TABLE `user_meta` DROP FOREIGN KEY `FK_f6c72c83c1787aee12530dbcd05`', undefined);
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('DROP INDEX `IDX_cede5795d48754d93e2636fa44` ON `user_meta`', undefined);
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` CHANGE `userId` `userId` varchar(36) NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_cede5795d48754d93e2636fa44` ON `user_meta` (`key`, `value`, `userId`)', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` ADD CONSTRAINT `FK_f6c72c83c1787aee12530dbcd05` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE CASCADE ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `session` CHANGE `userId` `userId` varchar(36) NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` ON `user` (`id`, `telegramId`, `publicId`)', undefined);
        await queryRunner.query('ALTER TABLE `organiser` CHANGE `desc` `desc` text NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `broadcasts` CHANGE `dateSent` `dateSent` datetime NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('DROP TABLE `jobs`', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `REL_3d2f174ef04fb312fdebd0ddc5` ON `session` (`userId`)', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
    }

}
