import {MigrationInterface, QueryRunner} from 'typeorm';

export class EventImageUrl1580335103121 implements MigrationInterface {
    public name = 'EventImageUrl1580335103121';

    public async up(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('ALTER TABLE `events` ADD `imageUrl` varchar(255) NOT NULL', undefined);
        await queryRunner.query('ALTER TABLE `broadcasts` CHANGE `dateSent` `dateSent` datetime NULL', undefined);
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('ALTER TABLE `events` DROP COLUMN `description`', undefined);
        await queryRunner.query('ALTER TABLE `events` ADD `description` varchar(2000) NOT NULL', undefined);
        await queryRunner.query('ALTER TABLE `event_attendees` DROP FOREIGN KEY `FK_07eb323a7b08ba51fe4b582f3f4`', undefined);
        await queryRunner.query('ALTER TABLE `event_attendees` DROP FOREIGN KEY `FK_21056813ffb169d392d38a40c2d`', undefined);
        await queryRunner.query('ALTER TABLE `event_attendees` CHANGE `userId` `userId` varchar(36) NULL', undefined);
        await queryRunner.query('ALTER TABLE `event_attendees` CHANGE `eventId` `eventId` varchar(36) NULL', undefined);
        await queryRunner.query('ALTER TABLE `jobs` CHANGE `status` `status` varchar(255) NULL', undefined);
        await queryRunner.query('ALTER TABLE `organiser` CHANGE `desc` `desc` text NULL', undefined);
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('ALTER TABLE `session` CHANGE `userId` `userId` varchar(36) NULL', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` DROP FOREIGN KEY `FK_f6c72c83c1787aee12530dbcd05`', undefined);
        await queryRunner.query('DROP INDEX `IDX_cede5795d48754d93e2636fa44` ON `user_meta`', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` CHANGE `userId` `userId` varchar(36) NULL', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` ON `user` (`id`, `telegramId`, `publicId`)', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_cede5795d48754d93e2636fa44` ON `user_meta` (`key`, `value`, `userId`)', undefined);
        await queryRunner.query('ALTER TABLE `event_attendees` ADD CONSTRAINT `FK_07eb323a7b08ba51fe4b582f3f4` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `event_attendees` ADD CONSTRAINT `FK_21056813ffb169d392d38a40c2d` FOREIGN KEY (`eventId`) REFERENCES `events`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE CASCADE ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` ADD CONSTRAINT `FK_f6c72c83c1787aee12530dbcd05` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE CASCADE ON UPDATE NO ACTION', undefined);
    }

    public async down(queryRunner: QueryRunner): Promise<any> {
        await queryRunner.query('ALTER TABLE `user_meta` DROP FOREIGN KEY `FK_f6c72c83c1787aee12530dbcd05`', undefined);
        await queryRunner.query('ALTER TABLE `session` DROP FOREIGN KEY `FK_3d2f174ef04fb312fdebd0ddc53`', undefined);
        await queryRunner.query('ALTER TABLE `event_attendees` DROP FOREIGN KEY `FK_21056813ffb169d392d38a40c2d`', undefined);
        await queryRunner.query('ALTER TABLE `event_attendees` DROP FOREIGN KEY `FK_07eb323a7b08ba51fe4b582f3f4`', undefined);
        await queryRunner.query('DROP INDEX `IDX_cede5795d48754d93e2636fa44` ON `user_meta`', undefined);
        await queryRunner.query('DROP INDEX `IDX_170405c65085bc6d51187e60ac` ON `user`', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` CHANGE `userId` `userId` varchar(36) NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_cede5795d48754d93e2636fa44` ON `user_meta` (`key`, `value`, `userId`)', undefined);
        await queryRunner.query('ALTER TABLE `user_meta` ADD CONSTRAINT `FK_f6c72c83c1787aee12530dbcd05` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE CASCADE ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `session` CHANGE `userId` `userId` varchar(36) NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `session` ADD CONSTRAINT `FK_3d2f174ef04fb312fdebd0ddc53` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE CASCADE ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `organiser` CHANGE `desc` `desc` text NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `jobs` CHANGE `status` `status` varchar(255) NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `event_attendees` CHANGE `eventId` `eventId` varchar(36) NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `event_attendees` CHANGE `userId` `userId` varchar(36) NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `event_attendees` ADD CONSTRAINT `FK_21056813ffb169d392d38a40c2d` FOREIGN KEY (`eventId`) REFERENCES `events`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `event_attendees` ADD CONSTRAINT `FK_07eb323a7b08ba51fe4b582f3f4` FOREIGN KEY (`userId`) REFERENCES `user`(`id`) ON DELETE NO ACTION ON UPDATE NO ACTION', undefined);
        await queryRunner.query('ALTER TABLE `events` DROP COLUMN `description`', undefined);
        await queryRunner.query('ALTER TABLE `events` ADD `description` varchar(999) NOT NULL', undefined);
        await queryRunner.query('CREATE UNIQUE INDEX `IDX_170405c65085bc6d51187e60ac` ON `user` (`id`, `telegramId`, `publicId`)', undefined);
        await queryRunner.query('ALTER TABLE `broadcasts` CHANGE `dateSent` `dateSent` datetime NULL DEFAULT \'NULL\'', undefined);
        await queryRunner.query('ALTER TABLE `events` DROP COLUMN `imageUrl`', undefined);
    }

}
