import { Column, CreateDateColumn, Entity, PrimaryGeneratedColumn, Unique } from 'typeorm';

@Entity()
@Unique(['id', 'name'])
export class Organiser {

  @PrimaryGeneratedColumn('uuid')
  public id: string;

  @Column({ type: 'varchar' })
  public name: string;

  @Column({
    nullable: true,
    type: 'text'
  })
  public desc?: string;

  @CreateDateColumn()
  public dateCreated: Date;
}
