import { Column, CreateDateColumn, Entity, ManyToOne, PrimaryColumn, Unique } from 'typeorm';

import { User } from './user.entity';

@Entity()
@Unique(['id'])
export class Session {

  @PrimaryColumn('uuid')
  public id: string;

  @ManyToOne((type) => User, { eager: true, onDelete: 'CASCADE' })
  public user: User;

  @Column()
  public userAgent: string;

  @Column({
    type: 'int',
    width: 11,
    unsigned: true,
    transformer: {
      to: (value: number) => value / 1000, // writing to db
      from: (value: number) => value * 1000 // reading from db
    }
  })
  public dateStarted: number;
}
