import { CanActivate, ExecutionContext, Injectable } from '@nestjs/common';
import { Request } from 'express';

@Injectable()
export class UserSessionGuard implements CanActivate {

    public canActivate(context: ExecutionContext): boolean {
        // TODO: add custom activation/deactivation metadata?
        // https://docs.nestjs.com/guards#putting-it-all-together
        const req = context.switchToHttp().getRequest() as Request;
        if (req?.userSession?.user?.id) {
            return true;
        }

        return false;
    }
}
